// An interface for working with the BBB GPIO to control servos
//
//
//
//
//
#include <Servo.h>
 
  Servo tiltServo;  
  Servo rotateServo;  
              
   //global for starting up 
  int startup = 1;
 
   //angle to move 
  int movement = 5;
 
  ////delay//////////
  int movement_Delay= 100;
  int setup_delay = 2000;
  int poll_delay = 600;
   
  /////postion tracking///
  int tiltPos = 90;    // variable to store the servo position
  int rotatePos = 90  ;    // variable to store the servo position  
 
 /////////////PINS//////////
 
 
  int rotateLeftPin = 11;
  int rotateRightPin = 10;
 
  int tiltUpPin = 9;
  int tiltDownPin = 8;
    
  int tiltServoPin = 7;
  int rotateServoPin = 6;
 
 //////values//////
 
  
  int rotateLeft = 0;
  int rotateRight = 0;
 
  int tiltUp = 0;
  int tiltDown = 0;
 

 
void setup()
{
  Serial.begin(9600);
  
  rotateServo.attach(rotateServoPin);  // attaches the servo on pin 9 to the servo object
  tiltServo.attach(tiltServoPin);  // attaches the servo on pin 9 to the servo object
  
  pinMode(rotateLeftPin, INPUT);
  pinMode(rotateRightPin, INPUT);
  pinMode(tiltUpPin, INPUT);
  pinMode(tiltDownPin, INPUT);
}

    
 
void loop()
{
  //startup
  if(startup == 1)
  {
      tiltServo.write(tiltPos);              
      delay(setup_delay);     
      
      rotateServo.write(rotatePos);              
      delay(setup_delay);  
      startup = 0;
  } 
  

  delay(poll_delay); 
  
   rotateLeft = digitalRead(rotateLeftPin);
   rotateRight = digitalRead(rotateRightPin);
   tiltUp = digitalRead(tiltUpPin);
   tiltDown = digitalRead(tiltDownPin);
   

 
  Serial.println("rotateleft value: ");
    Serial.println(rotateLeft);
   Serial.println("rotateRight value: ");
     Serial.println(rotateRight);
    Serial.println("postions: ");
   Serial.println(rotatePos);
Serial.println("==================");

 

  Serial.println("up value: ");
    Serial.println(tiltUp);
   Serial.println("down value: ");
     Serial.println(tiltDown);
    Serial.println("postions: ");
   Serial.println(tiltPos);
Serial.println("==================");

 
  if((rotateLeft == 1) & (rotateRight == 0 )& (rotatePos < 180) )
  {
     //Serial.println("TO LEFT");
     rotatePos = rotatePos + movement;
     rotateServo.write(rotatePos);              
     delay(movement_Delay);  
  }
 
  if((rotateRight == 1) & (rotateLeft == 0 ) & (rotatePos > 0))
  {
     //Serial.println("TO RIGHT");
     rotatePos = rotatePos - movement;
     rotateServo.write(rotatePos);              
     delay(movement_Delay);  
  }
  

  if((tiltUp == 1) & (tiltDown == 0) & (tiltPos < 180))
  {
     //Serial.println("TO UP");
     tiltPos = tiltPos + movement;
     tiltServo.write(tiltPos);              
     delay(movement_Delay);  
  }
 
  if((tiltDown == 1) & (tiltUp ==  0 ) & (tiltPos > 0))
  {
     //Serial.println("TO DOWN");
     tiltPos = tiltPos - movement;
     tiltServo.write(tiltPos);              
     delay(movement_Delay);  
  }
}

